#include "Transformation.h"



namespace CHCDemoEngine 
{

CGparameter Transformation::sModelMatrixParam;

Transformation::Transformation(Matrix4x4 *trafo): mMatrix(trafo)
{
}


Transformation::~Transformation
{
}


void Transformation::Load(RenderState *state)
{
	if (!mMatrix) return;

	if (state->GetRenderType() == RenderState::DEFERRED)
	{
		cgGLSetMatrixParameterfc(sModelMatrixParam, (const float *)mTransform->x);
	}
	else
	{
		glPushMatrix();
		glMultMatrixf((float *)mTransform->x);
	}
}


void Transformation::Unload(RenderState *state)
{
	if (!mMatrix) return;

	if (state->GetRenderType() == RenderState::DEFERRED)
	{
		static Matrix4x4 identity = IdentityMatrix();
		cgGLSetMatrixParameterfc(sModelMatrixParam, (const float *)identity.x);
	}
	else
	{
		glPopMatrix();
	}
}

}